/****************************************************************************
|                         Digital Audio Processor
|                         =======================
|
| Filename    : schroede.h
|
| Object      : DSPKitSchroederReverb
|
| Description : DSPKitSchroederReverb
|
| (c) Richard Kent 1996
|
| $Id: schroede.h,v 1.1 2003/09/10 00:06:25 rk Exp $
|
****************************************************************************/

#ifndef _DSPKIT_SCHROEDER_H_
#define _DSPKIT_SCHROEDER_H_

#include "processo.h"
#include "comb.h"
#include "allpassn.h"

class DSPKitSchroederReverb : public DSPKitProcessor
{
  public:

    DSPKitSchroederReverb ();
    int setInput (DSPKitProcessor *ip);
    int setInput (DSPKitProcessor *ip,double size,double spread);
    void setReverbTime (double rt);
    double getReverbTime () const;

  protected:

    double               reverbTime;
    DSPKitMux            mux;
    DSPKitComb           comb1;
    DSPKitComb           comb2;
    DSPKitComb           comb3;
    DSPKitComb           comb4;
    DSPKitSum            sum;
    DSPKitAmp            amp;
    DSPKitAllPassNetwork allpass1;
    DSPKitAllPassNetwork allpass2;
};

inline DSPKitSchroederReverb::DSPKitSchroederReverb ()
{
  reverbTime = 1.0;
}

inline double DSPKitSchroederReverb::getReverbTime () const
{
  return reverbTime;
}

#endif

/***************************************************************************/
